# bdm::EKFfull Class Reference

Extended Kalman Filter in full matrices. More...

`#include <kalman.h>`

List of all members.

## Public Member Functions
| EKFfull ()
| Default constructor.
void | set_parameters (const shared_ptr< diffbifn > &pfxu, const shared_ptr< diffbifn > &phxu, const mat Q0, const mat R0)
| Set nonlinear functions for mean values and covariance matrices.
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
void | set_statistics (vec mu0, mat P0)
| set estimates
const epdf & | posterior () const
| dummy!
const mat | _R ()
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | from_setting (const Setting &set)
| This method arrange instance properties according the data stored in the Setting structure.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
virtual void | validate ()
| This method TODO.
Constructors
virtual BM * | _copy_ () const
Mathematical operations
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs conditional density of 1-step ahead predictor .
Access to attributes
const RV & | _drv () const
void | set_drv (const RV &rv)
void | set_rv (const RV &rv)
double | _ll () const
void | set_evalll (bool evl0)
## Public Attributes
vec | mu
| Mean value of the posterior density.
mat | P
| Variance of the posterior density.
bool | evalll
double | ll
## Protected Attributes
shared_ptr< diffbifn > | pfxu
| Internal Model f(x,u).
shared_ptr< diffbifn > | phxu
| Observation Model h(x,u).
enorm< fsqmat > | E
int | dimx
int | dimy
int | dimu
mat | A
mat | B
mat | C
mat | D
mat | R
mat | Q
mat | _Pp
mat | _Ry
mat | _iRy
mat | _K
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
## Friends
std::ostream & | operator<< (std::ostream &os, const KalmanFull &kf)
| print elements of KF
## Extension to conditional BM
This extension is useful e.g. in Marginalized Particle Filter (bdm::MPF). Alternatively, it can be used for automated connection to DS when the condition is observed
const RV & | _rvc () const
| access function
virtual void | condition (const vec &val)
| Substitute `val` for `rvc`.
RV | rvc
| Name of extension variable.
## Logging of results
virtual void | set_options (const string &opt)
| Set boolean options from a string, recognized are: "logbounds,logll".
virtual void | log_add (logger &L, const string &name="")
| Add all logged variables to a logger.
virtual void | logit (logger &L)
ivec | LIDs
| IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll].
ivec | LFlags
| Flags for logging - same size as LIDs, each entry correspond to the same in LIDs.

## Detailed Description

Extended Kalman Filter in full matrices.

An approximation of the exact Bayesian filter with Gaussian noices and non-linear evolutions of their mean.

## Member Function Documentation

virtual BM* bdm::BM::_copy_ | ( |  | ) | const`[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:

     BM* _copy_() const {return new BM(*this);}

Reimplemented in bdm::ARX, bdm::KalmanCh, bdm::EKF< sq_T >, bdm::EKFCh, and bdm::BMEF.

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

Referenced by bdm::BM::logpred_m().

The documentation for this class was generated from the following files:

- kalman.h
- kalman.cpp